#
# spec file for package yup (Version 232)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

Name:           yup
%if 0%{?suse_version} < 1010
BuildRequires:  libidn-devel openssl-devel
%define		curl_name	curl
%define		curl_version	7.15.5
License:        GPL v2 or later
%else
License:        GPL v2 or later
BuildArch:      noarch
%endif
Version:        232
Release:        4.1
Summary:        "Yum Update Proxy" for SLE 10 Maintenance
Source0:        yup.sh
Source1:        yup.sysconfig
Source2:        yup.1.pod
Source3:        COPYING.GPL
Source4:        yup.permissions
Source5:        yup2zlm.sh
Source6:        yup2zlm.sysconfig
Source7:        Advanced_SLES10_Patching_0.2.pdf
Source8:        YUP-SLE10SP1-notes.pdf
Source9:        switch-enterprise-nu-mirror
%if 0%{?suse_version} < 1010
Source10:       %{curl_name}-%{curl_version}.tar.bz2
Patch2:         %{curl_name}-%{curl_version}-lfs.patch
Patch3:         %{curl_name}-%{curl_version}-aliasing.patch
Patch4:         %{curl_name}-%{curl_version}-ipv6tests.patch
Patch5:         %{curl_name}-%{curl_version}-epsv-firewall.patch
Patch6:         %{curl_name}-%{curl_version}-CVE-2006-1061.patch
%endif
Group:          System/YaST
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  perl
%if 0%{?suse_version}
PreReq:         %fillup_prereq
%endif
Requires:       curl

%description 
This packages allows to configure an update-mirror for Novell
maintenance packages for SUSE Linux Enterprise 10.

Please make sure, that the number of systems to serve with the mirrored
packages is in compliance with the number of subscriptions you are
allowed to exercise according to your contract with Novell.



Authors:
--------
    Marcus Meissner
    Eberhard Moenkeberg
    Matthias Eckermann

%if 0%{?suse_version} < 1010
%endif

%prep
%if 0%{?suse_version} < 1010
%setup -T -c -n %{curl_name}-%{curl_version} -a 10
cd %{curl_name}-%{curl_version}
%patch2
##- %patch3
%patch4
%patch5
##- %patch6
%else
%setup -T -c
%endif

%build
pod2man --center=" " --release="%{version}-%{release}" --date="$(date)" %{S:2} > yup.$$$$;
perl -p -e 's/.if n .na/.\\\".if n .na/;' yup.$$$$ > yup.1;
rm -f yup.$$$$
%if 0%{?suse_version} < 1010
cd %{curl_name}-%{curl_version}
autoreconf -fi
CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" 	\
./configure			 		\
			--prefix=%{_prefix} 	\
			--program-suffix=-yup	\
			--enable-ipv6 		\
			--with-ssl 		\
			--enable-static		\
			--disable-shared	\
			--libdir=%{_libdir}
make %{?jobs:-j%jobs}
%endif

%install
if [ -n "$RPM_BUILD_ROOT" ] ; then
   [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi
%if 0%{?suse_version} < 1010
cd %{curl_name}-%{curl_version}
make install DESTDIR=$RPM_BUILD_ROOT mandir=%{_mandir}
if [ -n "$RPM_BUILD_ROOT" ] ; then
	rm -rf $RPM_BUILD_ROOT/usr/src
	rm -rf $RPM_BUILD_ROOT/usr/%{_libdir}
	rm -rf $RPM_BUILD_ROOT/%{_libdir}
	rm -rf $RPM_BUILD_ROOT/usr/include
	rm -rf $RPM_BUILD_ROOT/usr/share/man
	rm -rf $RPM_BUILD_ROOT/usr/bin/curl-config-yup
	rm -rf $RPM_BUILD_ROOT/usr/share/curl/curl-ca-bundle.crt
fi
cd ..
%endif
mkdir -p	$RPM_BUILD_ROOT/usr/sbin		\
		$RPM_BUILD_ROOT/etc/permissions.d	\
		$RPM_BUILD_ROOT/usr/share/man/man1	\
		$RPM_BUILD_ROOT/var/adm/fillup-templates
install %{S:0}	$RPM_BUILD_ROOT/usr/sbin/yup
cp -a %{S:7} .
cp -a %{S:8} .
cp -a %{S:9} .
install %{S:5}	$RPM_BUILD_ROOT/usr/sbin/yup2zlm
install %{S:6}	$RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.yup2zlm
install %{S:1}	$RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.yup
install -m 644 yup.1	$RPM_BUILD_ROOT/usr/share/man/man1/yup.1
%if 0%{?suse_version} < 1010
sed -i -e "s,/usr/bin/curl,/usr/bin/curl-yup,g" $RPM_BUILD_ROOT/usr/sbin/yup
sed -i -e "s,/usr/bin/curl,/usr/bin/curl-yup,g" $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.yup
sed -i -e "s,/usr/bin/curl,/usr/bin/curl-yup,g" $RPM_BUILD_ROOT/usr/share/man/man1/yup.1
%endif
gzip -9 	$RPM_BUILD_ROOT/usr/share/man/man1/yup.1
cp -a %{S:3} .
#
rpm -qa --queryformat='%%{name}/%%{version}/%%{release}/%%{arch}\n'| sort | bzip2 -9 > USEDFORBUILD.bz2
#

%files
%defattr(-,root,root)
%attr(700, root, root) /usr/sbin/yup
%attr(700, root, root) /usr/sbin/yup2zlm
%attr(644, root, root) /usr/share/man/man1/yup.1.gz
%attr(600, root, root) /var/adm/fillup-templates/sysconfig.yup
%doc COPYING.GPL
%if 0%{?suse_version} < 1010
%doc %{curl_name}-%{curl_version}/{CHANGES,README,COPYING} 
%doc %{curl_name}-%{curl_version}/docs/{BUGS,CONTRIBUTE,FAQ,FEATURES,INTERNALS,MANUAL,RESOURCES,TODO,TheArtOfHttpScripting}
%{_prefix}/bin/curl-yup
%endif
%doc Advanced_SLES10_Patching_0.2.pdf YUP-SLE10SP1-notes.pdf switch-enterprise-nu-mirror
%attr(600, root, root) /var/adm/fillup-templates/sysconfig.yup2zlm
%doc USEDFORBUILD.bz2

%post
%if 0%{?suse_version}
%{fillup_only -n yup}
%{fillup_only -n yup2zlm}
%endif
chmod go-r /etc/sysconfig/yup*

%clean
if [ -n "$RPM_BUILD_ROOT" ] ; then
   [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
fi

%changelog
* Fri Nov 13 2009 meissner@suse.de
- added SP4 support too
* Sun Oct 18 2009 chris@computersalat.de
- removed changes from spec
- added SP3 for SLE10
- reworked HAE support
  o added YUP_HAE
  o can be added as HAE11 to YUP_PRODUCTS or YUP_HAE="yes"
- fixed Debug
  o enabling YUP_DEBUGINFO should work for SLES10 and SLES11
    did not for SLES11
- fixed SDK
  o enabling YUP_SDK should work for SLES10 and SLES11
    did not for SLES11
- fixed "${UPD}." != "."
  o for this to work ${UPD} should be UPD=""
* Mon Aug 24 2009 meissner@suse.de
- added SLE-HAE/11 support (from Michael Smith <msmith@cbnco.com>)
* Wed Apr  1 2009 meissner@suse.de
- fixed order of filename and checksum in deltainfo.xml
* Fri Mar 27 2009 meissner@suse.de
- Added SLE11 support.
  - SLED11, SLES11, SDK11, DEBUG11 added
  - deltainfo.xml.gz handling to download delta rpms.
* Thu Dec  6 2007 meissner@suse.de
- updated switch-enterprise-nu-mirror to 0.34 from Andreas #309861
- introduce YUP_SP_SUBCHANS as requested by Robert Zondervan
- minor, but powerful change by Robert Zondervan - thanks
- add ability to find duplicate file and hardlink to safe space
* Fri Sep  7 2007 meissner@suse.de
- updated switch-update-server (0.27) from Andreas,
  more bugfixes, other architectures.
- download to temporary files to avoid file corruption
  on aborted downloads.
* Tue Aug 28 2007 meissner@suse.de
- updated switch-update-server version from Andreas Taschner.
  Added SDK support, more debugging output.
* Mon Aug 27 2007 meissner@suse.de
- do not remove the SP1 catalog, it might be needed for
  later installations. #304851
* Tue Jul 10 2007 meissner@suse.de
- Also be able to handle OES2 once released.
- updated switch-enterprise-nu-mirror script with
  hopefully most bugs fixed and capable to migrate
  both SLES10 and SLED10 hosts.
* Tue Jul  3 2007 meissner@suse.de
- Added a switch-enterprise-nu-mirror script, to run at
  the remote machine for GA -> SP1 migration using YUP
  mirrored repositories.
  This is sample script only, please test careful before
  deploying.
* Mon Jun 25 2007 mge@novell.com
- add and package yup2zlm beta 0.4
* Fri Jun 22 2007 mge@novell.com
- do not package yup2zlm for now
* Thu Jun 21 2007 mge@novell.com
- better handling of metadata
- man-page enhancements
* Wed May 23 2007 mge@novell.com
- better permissions support
* Tue May 22 2007 mge@novell.com
- adopt for SLE 10 SP 1
- add yup2zlm by Jo de Baer
* Tue Feb 13 2007 rdassen@novell.com
- yup.1.pod: Fixed typo paramters -> parameters
* Mon Jan 15 2007 mge@suse.de
- apply small patch of Peter Surda - Thanks to him:
  * introduce "--time-cond $localfile" to curl-download
  * fix typo (YUP instead of correct YOU)
* Tue Dec  5 2006 mge@suse.de
- add /etc/permissions.d/yup
* Wed Nov 29 2006 mge@suse.de
- enable use of several configuration files below
  /etc/sysconfig/yup.d
  (following a proposal of Marcel Ritter)
* Thu Nov 16 2006 mge@suse.de
- verify bin and src rpms,
  thanks to Andreas Taschner for help
* Wed Nov  8 2006 mge@suse.de
- add downloading of src.rpms from you.novell.com
* Mon Oct 30 2006 mge@suse.de
- introduce YUP_SRCRPM variable and combine with
  patch/idea from Heiko Helmle posted on suse-sles-s
  Date: Mon, 30 Oct 2006 09:36:37 +0100
  Subject: New YUP version 47-0.6
* Tue Oct 24 2006 meissner@suse.de
- fixed the regular expressions for the sysconfig
  variable range. [:xdigit:]{32} -> ^[[:xdigit:]]{32}$
* Fri Oct 13 2006 rdassen@novell.com
- Reworked the manual page.
* Thu Oct 12 2006 rdassen@novell.com
- SLES9's bash does not support `+=' for adding to strings. Changed to good
  old foo="$foo bar" idiom.
* Wed Oct 11 2006 rdassen@novell.com
- Reworked error handling again.
- Keep using "set -e". The error handling philosophy used is one of exception
  handling: catch and handle "expected" errors, but error out immediately on
  unexpected errors.
- Do not exit immediately when a download of non-metadata (like an individual
  RPM or patch file) fails, but record the error and do a delayed error exit
  at the end (similar to tar's error handling).
- Replaced the
  command | while read line; do ... done
  idiom by
  command > tempfile
  {
  while read line; do ... done
  } < tempfile
  With the first idiom, the while loop runs as a separate process, which
  complicates keeping track of errors that have been caught. With the second
  idiom, the while loop runs in the same process so we can simply use a
  variable to track errors.
- Allocate and clean up a second temporary file for use with this idiom.
  Renamed variable name for the first temporary file for clarity.
- Track errors that are caught using a variable "errorlog".
* Tue Oct 10 2006 mge@suse.de
- add YUP_DEBUGINFO; possible fix for Bug #208545
- add YUP_SDK
* Tue Sep 26 2006 rdassen@novell.com
- Propagate exit values for non-simple commands to really exit at errors.
- Use "yup" in the name of temp files.
* Tue Sep 19 2006 mge@suse.de
- Add better error handling; patch by Ray Dassen
  Fixes Novell Bug #206660
* Fri Sep 15 2006 mge@suse.de
- add support for multiple architectures
- add support for different curl-path (YUP_CURL)
- add support for different keys for SLES, SLED and other products
  ( YUP_ID_SLED YUP_PASS_SLED YUP_ID_SLES YUP_PASS_SLES )
* Thu Aug 31 2006 meissner@suse.de
- fixed typo in script for older bash versions.
* Wed Aug 30 2006 meissner@suse.de
- Initial import of YUM REPO-MD mirror script for update.novell.com.
